discussion/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    # general end point        #app    #endpoints
    path('todolist/', include('todolist.urls')),
    path('admin/', admin.site.urls),
]

todolist/urls.py
from django.urls import path

from . import views



app_name = 'todolist'
urlpatterns = [
	# the path() function receive four arguments
	# We'll focus on 2 arguments that are required, 'route(end point)' and 'view(index function)'
	# 
	path('', views.index, name='index'),

	# todolist/<todoitem_id>
	# todolist/1
	# the <int:todoitem_id>/ allows for creating a dynamic link where the todoitem_id is provided
	path('<int:todoitem_id>/', views.todoitem,name="viewtodoitem"),


	path('register', views.register, name="register"),

	path('change_password', views.change_password, name="change_password"),

	path('login', views.login_view, name="login"),

	path('logout', views.logout_view, name="logout"),

	path('add_task', views.add_task, name="add_task")
]

todolist/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.
class ToDoItem(models.Model):
	task_name = models.CharField(max_length=50)
	description = models.CharField(max_length=200)
	status = models.CharField(max_length=50, default = "pending")
	date_created = models.DateTimeField("date created")
	user = models.ForeignKey(User, on_delete=models.CASCADE, default="")

todolist/forms.py
from django import forms

class LoginForm(forms.Form):
	username = forms.CharField(label="Username", max_length=20)
	password = forms.CharField(label="Password", max_length=20)


class AddTaskForm(forms.Form):
	task_name = forms.CharField(label="Task Name", max_length=50)
	description = forms.CharField(label="Description", max_length=200)


class RegisterForm(forms.Form):
	username = forms.CharField(label="Username", max_length=20)
	first_name = forms.CharField(label="First Name", max_length=20)
	last_name = forms.CharField(label="Last Name", max_length=20)
	email = forms.CharField(label="Email", max_length=20)
	password = forms.CharField(label="Password", max_length=20)
	confirm_password = forms.CharField(label="Confirm Password", max_length=20)

todolist/views.py
from django.shortcuts import render, redirect, get_object_or_404

# Create your views here.
from django.http import HttpResponse
from .models import ToDoItem
from .forms import LoginForm, AddTaskForm, RegisterForm
from django.contrib.auth.models import User
from django.contrib.auth import authenticate, login, logout
from django.forms.models import model_to_dict
from django.utils import timezone
from django.contrib.auth.hashers import make_password



def index(request):
	todoitem_list = ToDoItem.objects.filter(user_id=request.user.id)
	context = {
		"todoitem_list" : todoitem_list,
		"user": request.user
	}
	# context = {'todoitem_list' : todoitem_list}
	return render(request, "todolist/index.html", context)
	#return HttpResponse("Hello from the views.py file")


def todoitem(request, todoitem_id):
	todoitem = get_object_or_404(ToDoItem, pk=todoitem_id)
	# response = "You are viewing the details of %s"
	# return HttpResponse(response %todoitem_id)
	return render(request, "todolist/todoitem.html", model_to_dict(todoitem))


def register(request):

	context = {}

	if request.method == "POST":
		form = RegisterForm(request.POST)
		if form.is_valid() == False:
			form = RegisterForm()
		else: 
			username = form.cleaned_data['username']
			first_name = form.cleaned_data['first_name']
			last_name = form.cleaned_data['last_name']
			email = form.cleaned_data['email']
			password = form.cleaned_data['password']
			confirm_password = form.cleaned_data['confirm_password']
			duplicate = User.objects.filter(username =  username) 

			if not duplicate:
				User.objects.create(username=username, first_name=first_name, last_name=last_name, email=email, password=make_password(password), is_staff = False, is_active = True)
				


				context = {
					"first_name" : first_name,
					"last_name" : last_name
				}
				return redirect("todolist:index")
			else: 
				context = {
                    "error" : True
                }
	return render(request, "todolist/register.html", context)

	# users = User.objects.all()
	# is_user_registered = False
	# context = {
	# 	"is_user_registered" : is_user_registered
	# }

	# # for loop
	# # check if a username "johndoe" already exist
	# # if it exist change the value of variable is_user_registered to True
	# for indiv_user in users:
	# 	if indiv_user.username == "johndoe":
	# 		is_user_registered = True
	# 		break;

	# if is_user_registered == False:
	# 	user = User() # empty object
	# 	user.username = "johndoe"
	# 	user.first_name = "John"
	# 	user.last_name = "Doe"
	# 	user.email = "john@mail.com"

	# 	#password hashing
	# 	# The set_password is used to ensure that the pw is hashed using Django's authentication framework
	# 	user.set_password("John1234")
	# 	user.is_staff = False
	# 	user.is_active = True
	# 	user.save()


	# 	context = {
	# 		"first_name" : user.first_name,
	# 		"last_name" : user.last_name
	# 	}


	# return render(request, "todolist/register.html", context)


def change_password(request):

	is_user_authenticated = False

	user = authenticate(username="johndoe", password="John1234")
	print(user)
	if user is not None:
	    authenticated_user = User.objects.get(username='johndoe') # this is where we get the user with username 'John Doe'
	    authenticated_user.set_password("johndoe1")
	    authenticated_user.save()
	    is_user_authenticated = True
	context = {
	    "is_user_authenticated": is_user_authenticated
	}

	return render(request, "todolist/change_password.html", context)


def login_view(request):

	context = {}
	if request.method == "POST":
		# create a form instance and populate it with data from the request
		form = LoginForm(request.POST)
		# Check wether the data is valid
		# runs validation routines for all the form fields and returns true and places the form's data ub tge cleaned_data attribute
		if form.is_valid() == False:
			#returns a blank login form
			form = LoginForm()
		else:
			# receives the info from the form
			username = form.cleaned_data['username']
			password = form.cleaned_data['password']
			user = authenticate(username=username, password=password)
			context = {
				"username" : username,
				"password" : password
			}
			if user is not None: 
				login(request, user) 
				return redirect("todolist:index") 
			else:
				context = {
		            "error": True
		        }
		        # Provides context with error to conditionally render the error message
		        
                # Saves the user’s ID in the session using Django's session framework
	        
	       	

	return render(request, "todolist/login.html", context)



	# username = "johndoe"
	# password = "johndoe1"
	# user = authenticate(username=username, password=password)
	# context = {
	# 	"is_user_authenticated" : False
	# }
	# print(user)
	# if user is not None:
	# 	login(request,user)
	# 	return redirect("todolist:index")
	# else:
	# 							# templates/todolist/login.html
	# 	return render(request, "todolist/login.html", context)


def logout_view(request):
	logout(request)
	return redirect("todolist:index")



def add_task(request):
    context = {}

    if request.method == "POST":
        form = AddTaskForm(request.POST)
        if form.is_valid() == False:
            form = AddTaskForm()
        else: 
            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']
            duplicate = ToDoItem.objects.filter(task_name =  task_name)

            if not duplicate:
                ToDoItem.objects.create(task_name=task_name, description=description, date_created=timezone.now(), user_id = request.user.id)
                return redirect("todolist:index")

            else: 

                context = {
                    "error" : True
                }

    return render(request, "todolist/add_task.html", context)

templates/base.html
<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>{% block title %} To Do App {% endblock %}</title>

	<!-- Bootstrap -->
	<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-Zenh87qX5JnK2Jl0vWa8Ck2rdkQ2Bzep5IDxbcnCeuOxjzrPF/et3URy9Bv1WTRi" crossorigin="anonymous">
</head>
<body>

	{% include "navbar.html" %}
	<h1>Hello World</h1>
	{% block content %}
	{% endblock %}


	<!-- Bootstrap -->
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-OERcA2EqjJCMA+/3y+gxIOqMEjwtxJY7qPCqsdltbNJuaOe923+mo//f6V8Qbsw3" crossorigin="anonymous"></script>

</body>
</html>

templates/navbar.html
<nav class="navbar navbar-expand-lg bg-light">
	  <div class="container-fluid">
	    <a class="navbar-brand" href="#">To Do App</a>
	    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
	      <span class="navbar-toggler-icon"></span>
	    </button>
	    <div class="collapse navbar-collapse" id="navbarNav">
	      <ul class="navbar-nav ms-auto">
	        <li class="nav-item">
	          <a class="nav-link" href="">Home</a>
	        </li>
	        <li class="nav-item">
	          <a class="nav-link" href="add_task">Add Task</a>
	        </li>
	        <li class="nav-item">
	          <a class="nav-link" href="login">Login</a>
	        </li>
	        <li class="nav-item">
	          <a class="nav-link" href="logout">Logout</a>
	        </li>
	      </ul>
	    </div>
	  </div>
	</nav>

todolist/templates/todolist/add_task.html
{% extends 'base.html' %}

{% block title %}Add Task{% endblock %}

{% block content %}
	<div class="container">
		<div class="row">
			<div class="col-6 offset-3">
				<h1 class="text-center my-3">Add A Task</h1>
				{% if error == True %}
					<p class="text-danger">Duplicate task found</p>
				{% endif %}
				<form action="{% url 'todolist:add_task' %}" method="post">
					{% csrf_token %}

					<div class="mb-3">
					    <label for="task_name">Task Name: </label>
					    <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
					</div>

					<div class="mb-3">
					    <label for="description">Description: </label>
					    <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
					</div>

					<div class="text-center">
				    	<input class="btn btn-success" type="submit" value="Add Task">
					</div>

				</form>
			</div>
		</div>
	</div>
{% endblock %}

todolist/templates/todolist/change_password.html
{% if is_user_authenticated == False %}
	<h1>Invalid User Credentials</h1>
	<p>Check if the username and password is correct</p>
{% else %}
	<h1>User Password Successfully Updated</h1>
	<p>The password has been successfully updated</p>
{% endif %}

todolist/templates/todolist/index.html
{% extends 'base.html' %}

<!-- Provides the title of the page to be provided in the template -->
<!-- This should correspond with the block name provided in the base.html -->
{% block title %} Home {% endblock %}

{% block content %}
    {% if todoitem_list and user.is_anonymous == False %}
        <h1 class="text-center my-3">Welcome {{ user.first_name }} {{user.last_name}}!</h1>
        <div class="containter">
            <div class = "row">
                <h3 class="text-center mb-3">My Task</h3>
                <ul class="list-group col-lg-2 offset-lg-5 text-center">
                {% for todoitem in todoitem_list %}
                    <li><a href="{% url 'todolist:viewtodoitem' todoitem.id %}">{{ todoitem.task_name }}</a></li>
                {% endfor %}
                </ul>
        </div>
        </div>       
    {% elif user.is_anonymous == True %}
        <h1 class="text-center my-3">You are not authorized to access this page.</h1>
        <p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>
    {% else %}
        <p>No tasks have been created.</p>
    {% endif %}
{% endblock %}

todolist/templates/todolist/login.html
{% extends 'base.html' %}

	{% block title %}Login{% endblock %}

	{% block content %}
	<div class="container">
		<div class="row">
			<div class="col-6 offset-3">
				<h1 class="text-center my-3">Login</h1>
				{% if error == True %}
					<p class="text-danger">Invalid user credentials, please check your username and password</p>
				{% endif %}
				<form action="{% url 'todolist:login' %}" method="post">
					<!-- This template tag provides protection against Cross Site Request Forgeries (CSRF) -->
					<!-- CSRF occurs when a malicious website contains a link, a form button or some JavaScript that is intended to perform some action our website, using the credentials of a logged-in user -->
					{% csrf_token %}

					<div class="mb-3">
					    <label for="username">Username: </label>
					    <input class="form-control" id="username" type="text" name="username" value="{{ username }}" maxlength="20" required>
					</div>

					<div class="mb-3">
					    <label for="password">Password: </label>
					    <input class="form-control" id="password" type="password" name="password" value="{{ password }}" maxlength="20" required>
					</div>

					<div class="text-center">
				    	<input class="btn btn-success" type="submit" value="Login">
					</div>

				</form>
			</div>
		</div>
	</div>
	{% endblock %}


<!-- {% if is_user_authenticated == False %}
		<h1>Something Went Wrong</h1>
		<p>Please contact your administrator or reset your password</p>
		<a href="{% url 'todolist:index' %}">Back to index page</a>
{% endif %} -->

todolist/templates/todolist/register.html
{% extends 'base.html' %}

	{% block title %}Register{% endblock %}

	{% block content %}
	<div class="container">
		<div class="row">
			<div class="col-6 offset-3">
				<h1 class="text-center my-3">Register</h1>
				<!-- {% if error == True %}
					<p class="text-danger">Invalid user credentials, please check your username and password</p>
				{% endif %} -->
				<!-- {% if is_user_registered == False %}
					<h1>Duplicate User Found</h1>
					<p>A duplicate user has been found, user creation unsuccessful</p>
				{% else %}
					<h1>User Successful Created</h1>
					<p>The account for {{firstname}} {{lastname}} has been successfully created</p>
				{% endif %} -->
				<form action="{% url 'todolist:register' %}" method="post">
					<!-- This template tag provides protection against Cross Site Request Forgeries (CSRF) -->
					<!-- CSRF occurs when a malicious website contains a link, a form button or some JavaScript that is intended to perform some action our website, using the credentials of a logged-in user -->
					{% csrf_token %}

					<div class="mb-3">
					    <label for="username">Username: </label>
					    <input class="form-control" id="username" type="text" name="username" value="{{ username }}" maxlength="20" required>
					</div>

					<div class="mb-3">
					    <label for="first_name">First Name: </label>
					    <input class="form-control" id="first_name" type="text" name="first_name" value="{{ first_name }}" maxlength="20" required>
					</div>

					<div class="mb-3">
					    <label for="last_name">Last Name: </label>
					    <input class="form-control" id="last_name" type="text" name="last_name" value="{{ last_name }}" maxlength="20" required>
					</div>

					<div class="mb-3">
					    <label for="email">Email: </label>
					    <input class="form-control" id="email" type="text" name="email" value="{{ email }}" maxlength="20" required>
					</div>

					<div class="mb-3">
					    <label for="password">Password: </label>
					    <input class="form-control" id="password" type="password" name="password" value="{{ password }}" maxlength="20" required>
					</div>

					<div class="mb-3">
					    <label for="confirm_password">Confirm Password: </label>
					    <input class="form-control" id="confirm_password" type="password" name="confirm_password" value="{{ confirm_password }}" maxlength="20" required>
					</div>

					<div class="text-center">
				    	<input class="btn btn-success" type="submit" value="Register">
					</div>

				</form>
			</div>
		</div>
	</div>
	{% endblock %}



<!-- {% if is_user_registered == False %}
	<h1>Duplicate User Found</h1>
	<p>A duplicate user has been found, user creation unsuccessful</p>
{% else %}
	<h1>User Successful Created</h1>
	<p>The account for {{firstname}} {{lastname}} has been successfully created</p>
{% endif %} -->

todolist/templates/todolist/todoitem.html
<h1>{{ task_name }}</h1>
<h3>Description</h3>
<p>{{ description }}</p>
<h3>Status</h3>
<p>{{ status }}</p>
<a href="{% url 'todolist:index' %}">Back to index page</a>